Scripts update to run rubbos on compass4nfv env 4
[bottlenecks.git] / utils / infra_setup / heat_template / HOT_create_instance.sh
index 49fa5e8..0e250fe 100755 (executable)
 #!/bin/bash
 
-set -ex
+set -x
 
-bottlenecks_env_prepare()
+git_checkout()
 {
-   if [ -d $BOTTLENECKS_REPO_DIR ]; then
-       rm -rf ${BOTTLENECKS_REPO_DIR}
-   fi
+    if git cat-file -e $1^{commit} 2>/dev/null; then
+        # branch, tag or sha1 object
+        git checkout $1
+    else
+        # refspec / changeset
+        git fetch --tags --progress $2 $1
+        git checkout FETCH_HEAD
+    fi
+}
+
+bottlenecks_env_prepare() {
+    set -e
+    echo "Bottlenecks env prepare start $(date)"
+    git config --global http.sslVerify false
+
+    if [ ! -d $BOTTLENECKS_REPO_DIR ]; then
+        git clone $BOTTLENECKS_REPO $BOTTLENECKS_REPO_DIR
+    fi
+    cd $BOTTLENECKS_REPO_DIR
+    git checkout master && git pull
+    git_checkout $BOTTLENECKS_BRANCH $BOTTLENECKS_REPO
+    cd -
+
+    echo "Creating openstack credentials .."
+    if [ ! -d $RELENG_REPO_DIR ]; then
+        git clone $RELENG_REPO $RELENG_REPO_DIR
+    fi
+    cd $RELENG_REPO_DIR
+    git checkout master && git pull
+    git_checkout $RELENG_BRANCH $RELENG_REPO
+    cd -
 
-   mkdir -p ${BOTTLENECKS_REPO_DIR}
-   git config --global http.sslVerify false
-   git clone ${BOTTLENECKS_REPO} ${BOTTLENECKS_REPO_DIR}
+    # Create openstack credentials
+    $RELENG_REPO_DIR/utils/fetch_os_creds.sh \
+        -d /tmp/openrc \
+        -i ${INSTALLER_TYPE} -a ${INSTALLER_IP}
 
-   source $BOTTLENECKS_REPO_DIR/rubbos/rubbos_scripts/1-1-1/scripts/env_preparation.sh
+    source /tmp/openrc
+
+    chmod 600 $KEY_PATH/bottlenecks_key
+
+    echo "Bottlenecks env prepare end $(date)"
+    set +e
 }
 
-bottlenecks_create_instance()
+wait_heat_stack_complete() {
+    retry=0
+    while true
+    do
+        status=$(heat stack-list | grep bottlenecks | awk '{print $6}')
+        if [ x$status = x"CREATE_COMPLETE" ]; then
+            echo "bottlenecks stacke create complete"
+            heat stack-show bottlenecks
+            nova list | grep rubbos_
+            break;
+        elif [ x$status = x"CREATE_FAILED" ]; then
+            echo "bottlenecks stacke create failed !!!"
+            heat stack-show bottlenecks
+            exit 1
+        fi
+
+        #if [ $BOTTLENECKS_DEBUG = True ]; then
+        if false; then
+            heat stack-show bottlenecks
+            nova list | grep rubbos_
+            for i in $(nova list | grep rubbos_ | grep ERROR | awk '{print $2}')
+            do
+                 nova show $i
+            done
+        fi
+        sleep 1
+        let retry+=1
+        if [[ $retry -ge $1 ]];then
+            echo "Heat stack create timeout, status $status !!!"
+            exit 1
+        fi
+    done
+}
+
+wait_rubbos_control_ok() {
+    control_ip=$(nova list | grep rubbos_control | awk '{print $13}')
+
+    retry=0
+    until timeout 3s ssh $ssh_args ubuntu@$control_ip "exit" >/dev/null 2>&1
+    do
+        echo "retry connect rubbos control $retry"
+        sleep 1
+        let retry+=1
+        if [[ $retry -ge $1 ]];then
+            echo "rubbos control start timeout !!!"
+            exit 1
+        fi
+    done
+    ssh $ssh_args ubuntu@$control_ip "uname -a"
+}
+
+bottlenecks_check_instance_ok()
 {
-   echo "create bottlenecks instance using heat template"
+    echo "Bottlenecks check instance ok start $(date)"
 
-   echo "upload keypair"
-   nova keypair-add --pub_key $KEY_PATH/bottleneck_key.pub $KEY_NAME
-   #need FIX, only upload the public key? should be keypair
+    wait_heat_stack_complete 120
+    wait_rubbos_control_ok 300
+    nova list | grep rubbos_
+    if [ $BOTTLENECKS_DEBUG = True ]; then
+        date
+        while true
+        do
+            for i in rubbos_benchmark rubbos_client1 rubbos_client2 rubbos_client3 \
+                     rubbos_client4 rubbos_control rubbos_httpd rubbos_mysql1 rubbos_tomcat1
+            do
+               echo "logging $i"
+               nova console-log $i | tail -n 2 | grep Cloud-init | grep finished
+               if [ $? != 0 ]; then
+                   break
+               fi
+               if [ $i = rubbos_tomcat1 ]; then
+                   echo "all vm Cloud-init finished!"
+                   date
+                   return
+               fi
+            done
+            sleep 10
+        done
+    fi
 
-   echo "use heat template to create stack"
-   cd $HOT_PATH
-   heat stack-create bottlenecks -f ${TEMPLATE_NAME} -P "image=$IMAGE_NAME;key=$KEY_NAME;public_network=$PUBLIC_NET_NAME"
-   #need FIX, use stack to create 9 VMs
+    echo "Bottlenecks check instance ok end $(date)"
 }
 
-bottlenecks_cleanup()
+bottlenecks_create_instance()
 {
-   echo "clean up bottlenecks images"
+    echo "Bottlenecks create instance using heat template start $(date)"
 
-   if ! glance image-list; then
-       return
-   fi
+    echo "upload keypair"
+    nova keypair-add --pub_key $KEY_PATH/bottlenecks_key.pub $KEY_NAME
 
-   #need to check
-   for image in $(glance image-list | grep -e $IMAGE_NAME | awk '{print $2}'); do
-       echo "clean up image $image"
-       glance image-delete $iamge || true
-   done
+    echo "create flavor"
+    nova flavor-create $FLAVOR_NAME 200 4096 20 2
+
+    echo "use heat template to create stack"
+    cd $HOT_PATH
+    heat stack-create bottlenecks -f ${TEMPLATE_NAME} \
+         -P "image=$IMAGE_NAME;key_name=$KEY_NAME;public_net=$EXTERNAL_NET;flavor=$FLAVOR_NAME"
+
+    echo "Bottlenecks create instance using heat template end $(date)"
 }
 
-bottlenecks_build_image()
+bottlenecks_rubbos_wait_finish()
 {
-   echo "build bottlenecks image"
+    echo "Start checking rubbos running status..."
+    retry=0
+    while true
+    do
+        ssh $ssh_args ubuntu@$control_ip "FILE=/tmp/rubbos_finished; if [ -f \$FILE ]; then exit 0; else exit 1; fi"
+        if [ $? = 0 ]; then
+            echo "Rubbos test case successfully finished :)"
+            return 0
+        fi
+        echo "Rubbos running $retry ..."
+        sleep 30
+        let retry+=1
+        if [[ $retry -ge $1 ]]; then
+            echo "Rubbos test case timeout :("
+            return 1
+        fi
+    done
+}
+
+bottlenecks_rubbos_run()
+{
+    echo "Run Rubbos"
+    control_ip=$(nova list | grep rubbos_control | awk '{print $13}')
+    for i in rubbos_benchmark rubbos_client1 rubbos_client2 rubbos_client3 \
+             rubbos_client4 rubbos_control rubbos_httpd rubbos_mysql1 \
+             rubbos_tomcat1
+    do
+          ip=$(nova list | grep $i | awk '{print $12}' | awk -F [=,] '{print $2}')
+          echo "$i=$ip" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    done
+
+    nameserver_ip=$(grep -m 1 '^nameserver' \
+        /etc/resolv.conf | awk '{ print $2 '})
+    echo "nameserver_ip=$nameserver_ip" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+
+    echo "GERRIT_REFSPEC_DEBUG=$GERRIT_REFSPEC_DEBUG" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    echo "BOTTLENECKS_BRANCH=$BOTTLENECKS_BRANCH" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
 
-   #need FIX
+    echo "NODE_NAME=$NODE_NAME" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    echo "INSTALLER_TYPE=$INSTALLER_TYPE" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    echo "BOTTLENECKS_VERSION=$BOTTLENECKS_VERSION" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    echo "BOTTLENECKS_DB_TARGET=$BOTTLENECKS_DB_TARGET" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+    echo "PACKAGE_URL=$PACKAGE_URL" >> $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
+
+    scp $ssh_args -r \
+        $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup \
+        ubuntu@$control_ip:/tmp
+    ssh $ssh_args \
+        ubuntu@$control_ip "bash /tmp/vm_dev_setup/setup_env.sh" &
+
+    bottlenecks_rubbos_wait_finish 200
+
+    if [ x"$GERRIT_REFSPEC_DEBUG" != x ]; then
+        # TODO fix hard coded path
+        scp $ssh_args \
+            ubuntu@$control_ip:"/bottlenecks/rubbos/rubbos_results/2015-01-20T081237-0700.tgz" /tmp
+    fi
+
+    rm -rf $BOTTLENECKS_REPO_DIR/utils/infra_setup/vm_dev_setup/hosts.conf
 }
 
-bottlenecks_load_cirros_image()
+bottlenecks_cleanup()
 {
-   echo "load bottlenecks cirros image"
+    echo "Bottlenecks cleanup start $(date)"
 
-   wget http://download.cirros-cloud.net/0.3.3/cirros-0.3.3-x86_64-disk.img -O /tmp/cirros.img
+    if heat stack-list; then
+        for stack in $(heat stack-list | grep -e bottlenecks | awk '{print $2}'); do
+            echo "clean up stack $stack"
+            heat stack-delete $stack || true
+            sleep 30
+        done
+    fi
 
-   result=$(glance image-create \
-       --name cirros-0.3.3 \
-       --disk-format qcow2 \
-       --container-format bare \
-       --file /tmp/cirros.img)
-   echo "$result"
+    if glance image-list; then
+        for image in $(glance image-list | grep -e $IMAGE_NAME | awk '{print $2}'); do
+            echo "clean up image $image"
+            glance image-delete $image || true
+        done
+    fi
 
-   rm -rf /tmp/cirros.img
+    if nova keypair-list; then
+        for key in $(nova keypair-list | grep -e $KEY_NAME | awk '{print $2}'); do
+            echo "clean up key $key"
+            nova keypair-delete $key || true
+        done
+    fi
 
-   IMAGE_ID_CIRROS=$(echo "$result" | grep " id " | awk '{print $(NF-1)}')
-   if [ -z "$IMAGE_ID_CIRROS" ]; then
-        echo 'failed to upload cirros image to openstack'
-        exit 1
-   fi
+    if nova flavor-list; then
+        for flavor in $(nova flavor-list | grep -e $FLAVOR_NAME | awk '{print $2}'); do
+            echo "clean up flavor $flavor"
+            nova flavor-delete $flavor || true
+        done
+    fi
 
-   echo "cirros image id: $IMAGE_ID_CIRROS"
+    echo "Bottlenecks cleanup end $(date)"
 }
 
-bottlenecks_load_image()
+bottlenecks_load_bottlenecks_image()
 {
-   echo "load bottlenecks image"
+    echo "Bottlenecks load image start $(date)"
 
-   result=$(glance --os-image-api-version 1 image-create \
-      --name $IMAGE_NAME \
-      --is-public true --disk-format qcow2 \
-      --container-format bare \
-      --file $IMAGE_FILE_NAME)
-   echo "$result"
+    curl --connect-timeout 10 -o /tmp/bottlenecks-trusty-server.img $IMAGE_URL -v
 
-   GLANCE_IMAGE_ID=$(echo "$result" | grep " id " | awk '{print $(NF-1)}')
+    result=$(glance image-create \
+        --name $IMAGE_NAME \
+        --disk-format qcow2 \
+        --container-format bare \
+        --file /tmp/bottlenecks-trusty-server.img)
+    echo "$result"
 
-   if [ -z "$GLANCE_IMAGE_ID" ]; then
-       echo 'add image to glance failed'
-       exit 1
-   fi
+    rm -rf /tmp/bottlenecks-trusty-server.img
 
-   sudo rm -f $IMAGE_FILE_NAME
+    IMAGE_ID_BOTTLENECKS=$(echo "$result" | grep " id " | awk '{print $(NF-1)}')
+    if [ -z "$IMAGE_ID_BOTTLENECKS" ]; then
+         echo 'failed to upload bottlenecks image to openstack'
+         exit 1
+    fi
 
-   echo "add glance image completed: $GLANCE_IMAGE_ID"
+    echo "bottlenecks image end id: $IMAGE_ID_BOTTLENECKS $(date)"
 }
 
 main()
 {
-   echo "create instances with heat template"
-
-   BOTTLENECKS_REPO=https://gerrit.opnfv.org/gerrit/bottlenecks
-   BOTTLENECKS_REPO_DIR=/tmp/opnfvrepo/bottlenecks
-   #IMAGE_URL=http://205.177.226.235:9999
-   IMAGE_NAME=cirros-0.3.3
-   #need FIX, need a script to transfer the image from the url to be the installer images
-   KEY_PATH=$BOTTLENECKS_REPO_DIR/utils/infra_setup/bottlenecks_key
-   HOT_PATH=$BOTTLENECKS_REPO_DIR/utils/infra_setup/heat_template
-   KEY_NAME=bottlenecks_key
-   TEMPLATE_NAME=bottlenecks_template1.yaml
-   PUBLIC_NET_NAME=net04_ext
-   #need FIX
-   #IMAGE_FILE_NAME=""
-
-   bottlenecks_env_prepare
-   #bottlenecks_cleanup
-   #bottlenecks_build_image
-   bottlenecks_load_cirros_image
-   bottlenecks_create_instance
+    echo "main start $(date)"
+
+    : ${BOTTLENECKS_DEBUG:='True'}
+    : ${BOTTLENECKS_REPO:='https://gerrit.opnfv.org/gerrit/bottlenecks'}
+    : ${BOTTLENECKS_REPO_DIR:='/tmp/opnfvrepo/bottlenecks'}
+    : ${BOTTLENECKS_BRANCH:='master'} # branch, tag, sha1 or refspec
+    : ${RELENG_REPO:='https://gerrit.opnfv.org/gerrit/releng'}
+    : ${RELENG_REPO_DIR:='/tmp/opnfvrepo/releng'}
+    : ${RELENG_BRANCH:='master'} # branch, tag, sha1 or refspec
+    : ${IMAGE_NAME:='bottlenecks-trusty-server'}
+    KEY_PATH=$BOTTLENECKS_REPO_DIR/utils/infra_setup/bottlenecks_key
+    HOT_PATH=$BOTTLENECKS_REPO_DIR/utils/infra_setup/heat_template
+    : ${KEY_NAME:='bottlenecks-key'}
+    : ${FLAVOR_NAME:='bottlenecks-flavor'}
+    : ${TEMPLATE_NAME:='bottlenecks_rubbos_hot.yaml'}
+    ssh_args="-o StrictHostKeyChecking=no -o BatchMode=yes -i $KEY_PATH/bottlenecks_key"
+    : ${EXTERNAL_NET:='net04_ext'}
+    : ${PACKAGE_URL:='http://artifacts.opnfv.org/bottlenecks'}
+    : ${NODE_NAME:='opnfv-jump-2'}
+    : ${INSTALLER_TYPE:='fuel'}
+    : ${INSTALLER_IP:='10.20.0.2'}
+    # TODO fix for dashboard
+    : ${BOTTLENECKS_VERSION:='master'}
+    : ${BOTTLENECKS_DB_TARGET:='213.77.62.197'}
+    IMAGE_URL=${PACKAGE_URL}/rubbos/bottlenecks-trusty-server.img
+
+    bottlenecks_env_prepare
+    set -x
+    bottlenecks_cleanup
+    bottlenecks_load_bottlenecks_image
+    bottlenecks_create_instance
+    bottlenecks_check_instance_ok
+    bottlenecks_rubbos_run
+    bottlenecks_cleanup
+    echo "main end $(date)"
 }
 
 main
-set +ex
+set +x